/*  www.sgm.siedlce.pl

prosty test detekcji 2 kanalow PPM, kiedy impulsy nie nastepuja
bezposrednio jednen za drugim, tak jak w przypadku odbiornika
Turnigy T9x8C V2 (kan1 i kan2 - lotki i wysokosc),
kan 8 jako warunek rozpoczecia detekcji

*/

byte PinRx1 = 8;  // sygnal kan1 podlaczony do Pin8 
byte PinRx2 = 10; // sygnal kan2 podlaczony do Pin10
byte PinRx3 = 12; // sygnal kan8 podlaczony do Pin12
                  // (poczatek detekcji)
                     
int PPM1 = 0;     // zmienna na dlugosc impulsu PPM1
int PPM2 = 0;     // zmienna na dlugosc impulsu PPM2
byte Rx3 = 0;     // zmienna pomocnicza (poczatek detekcji)

int Licz = 0;       // zmienne pozwalajace drukowac
int LiczMax = 10;   // co 20 impuls PPM1

void setup()
{
  pinMode(PinRx1,INPUT); // ustaw PinRx1 jako wejscie
  pinMode(PinRx2,INPUT); // ustaw PinRx2 jako wejscie
  pinMode(PinRx3,INPUT); // ustaw PinRx3 jako wejscie
  Serial.begin(57600);   // ustaw predkosc transmisji
}


void loop() {
 
 do                       //czekaj az pojawi sie impuls na kan8
 {                        //i wtedy rozpocznij detekcje kan1 i kan2
  Rx3=digitalRead(PinRx3); 
 } while (Rx3==0);
  Rx3=0;
  
 PPM1=pulseIn(PinRx1,HIGH); // detekcja impulsu PPM na PinRx1
 PPM2=pulseIn(PinRx2,HIGH); // detekcja impulsu PPM na PinRx2
 
 
 Licz += 1;                 // zwieksz licznik impulsow o 1 
 if (Licz>LiczMax) {        // drukuj wartosc co n-ty impuls

  Serial.print(PPM1);
  Serial.print(";  ");
  Serial.print(PPM2);
  Serial.println(";  ");
  
  Licz = 0;
 }
 
}
